/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.cpu.Shared.*;

public final class J extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         J.class,
         "J",
         new ArgumentDecls()
             .add("target", INDEX));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate target = (Immediate) getArgument("target", args);

      return new J(target);
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate target;

  public J(final Immediate target) {
    assert INDEX.equals(target.getType());
    this.target = target;
  }

  @Override
  public String syntax() {
    return String.format("j <label>%d", target.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("011%b", target.access().load().toBinString());
  }

  @Override
  public void action() {
    PC.access().store(target.access().load());
  }
}