/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.cpu.mode.*;

import static ru.ispras.microtesk.model.cpu.Shared.*;

public final class SUB extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SUB.class,
         "SUB",
         new ArgumentDecls(),
         new Shortcuts()
             .addShortcut(new Info_alu_instr(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new SUB();
    }
  }
  private static final class Info_alu_instr extends InfoAndRule {
    Info_alu_instr() {
      super(
          alu_instr.class,
          "SUB",
          new ArgumentDecls()
              .add("op1", OPRNDL.INFO)
              .add("op2", OPRNDR.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);
      final AddressingMode op2 = (AddressingMode) getArgument("op2", args);

      return new alu_instr(
        new SUB(),
        op1,
        op2
      );
    }
  }
  public static final IInfo INFO = new Info();

  public SUB() {
  }

  @Override
  public String syntax() {
    return "sub";
  }

  @Override
  public String image() {
    return "01";
  }

  @Override
  public void action() {
    DEST.access().store(SRC1.access().load().subtract(SRC2.access().load()));
  }
}