/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.metadata;

import static ru.ispras.microtesk.model.minimips.Shared.*;

import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.metadata.MetaModelBuilder;

/**
 * The {@code MetaModel} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModel extends MetaModelBuilder {
  public MetaModel() {
    addRegister("GPR", WORD, 32);
    addRegister("COP0_R", WORD, 32);
    addRegister("HI", WORD, 1);
    addRegister("LO", WORD, 1);
    addRegister("CIA", WORD, 1);
    addRegister("BRANCH", BIT, 1);
    addRegister("JMPADDR", WORD, 1);

    addMemory("M", WORD, 0x40000000);

    addMode(REG.get());
    addMode(RCOP0.get());

    addOperation(add.get());
    addOperation(addi.get());
    addOperation(addu.get());
    addOperation(addiu.get());
    addOperation(sub.get());
    addOperation(subu.get());
    addOperation(mult.get());
    addOperation(multu.get());
    addOperation(and.get());
    addOperation(andi.get());
    addOperation(or.get());
    addOperation(ori.get());
    addOperation(nor.get());
    addOperation(xor.get());
    addOperation(xori.get());
    addOperation(sll.get());
    addOperation(sllv.get());
    addOperation(sra.get());
    addOperation(srav.get());
    addOperation(srl.get());
    addOperation(srlv.get());
    addOperation(lui.get());
    addOperation(lw.get());
    addOperation(sw.get());
    addOperation(mfhi.get());
    addOperation(mflo.get());
    addOperation(mthi.get());
    addOperation(mtlo.get());
    addOperation(swc0.get());
    addOperation(lwc0.get());
    addOperation(mfc0.get());
    addOperation(mtc0.get());
    addOperation(beq.get());
    addOperation(bgez.get());
    addOperation(bgezal.get());
    addOperation(bgtz.get());
    addOperation(blez.get());
    addOperation(bltz.get());
    addOperation(bltzal.get());
    addOperation(bne.get());
    addOperation(slt.get());
    addOperation(slti.get());
    addOperation(sltiu.get());
    addOperation(sltu.get());
    addOperation(j.get());
    addOperation(jr.get());
    addOperation(jal.get());
    addOperation(jalr.get());
    addOperation(syscall.get());
    addOperation(cop0.get());
    addOperation(mips_break.get());
    addOperation(arithm.get());
    addOperation(arithmi.get());
    addOperation(multiply.get());
    addOperation(bitwise.get());
    addOperation(bitwisei.get());
    addOperation(shift.get());
    addOperation(shifti.get());
    addOperation(alu.get());
    addOperation(alui.get());
    addOperation(Operations.get());
    addOperation(instruction.get());
    addOperation(la.get());
  }
}
