/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class mult extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mult.class,
         "mult",
         new ArgumentDecls()
             .add("rs", REG.INFO)
             .add("rt", REG.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rs = (REG) getArgument("rs", args);
      final REG rt = (REG) getArgument("rt", args);

      return new mult(rs, rt);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "mult",
          new ArgumentDecls()
              .add("rs", REG.INFO)
              .add("rt", REG.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rs = (REG) getArgument("rs", args);
      final REG rt = (REG) getArgument("rt", args);

      return new instruction(
        new mult(
          rs,
          rt
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final REG rs;
  public final REG rt;

  public mult(final REG rs, final REG rt) {
    assert REG.INFO.isSupported(rs);
    assert REG.INFO.isSupported(rt);
    this.rs = rs;
    this.rt = rt;
  }

  @Override
  public String syntax() {
    return String.format("mult %s, %s", rs.syntax(), rt.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%s%s0000000000011000", rs.image(), rt.image());
  }

  @Override
  public void action() {
    mult_result.access().store(Data.signExtend(Type.INT(64), rs.access().load()).multiply(Data.signExtend(Type.INT(64), rt.access().load())));
    HI.access(0).store(mult_result.access().bitField(63, 32).load());
    LO.access(0).store(mult_result.access().bitField(31, 0).load());
  }
}