/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class syscall extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         syscall.class,
         "syscall",
         new ArgumentDecls(),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new syscall();
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "syscall",
          new ArgumentDecls()
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new instruction(
        new syscall()
      );
    }
  }
  public static final IInfo INFO = new Info();

  public syscall() {
  }

  @Override
  public String syntax() {
    return "syscall";
  }

  @Override
  public String image() {
    return "0000000000000000000000000001100";
  }

  @Override
  public void action() {
    COP0_R.access(14).store(CIA.access().load());
    Execution.exception("SystemCall");
  }
}