/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma;

import ru.ispras.microtesk.model.api.ProcessorModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelPrinter;
import ru.ispras.microtesk.model.api.state.ModelStatePrinter;
import ru.ispras.microtesk.model.api.instruction.AddressingMode;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.plasma.metadata.MetaModel;
import ru.ispras.microtesk.model.plasma.mode.*;
import ru.ispras.microtesk.model.plasma.op.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class Model extends ProcessorModel {
  public static final String NAME = "plasma";

  private static final AddressingMode.IInfo[] __MODES = new AddressingMode.IInfo[] {
    R.INFO,
    CPRGET.INFO,
    CPRSET.INFO,
    C0_R.INFO
  };

  private static final Operation.IInfo[] __OPS = new Operation.IInfo[] {
    nop.INFO,
    mips32_load.INFO,
    lb.INFO,
    lbu.INFO,
    lh.INFO,
    lhu.INFO,
    lw.INFO,
    mips32_store.INFO,
    sb.INFO,
    sh.INFO,
    sw.INFO,
    wait.INFO,
    beq.INFO,
    bgez.INFO,
    bgezal.INFO,
    bgtz.INFO,
    blez.INFO,
    bltz.INFO,
    bltzal.INFO,
    bne.INFO,
    break_ins.INFO,
    j.INFO,
    jal.INFO,
    jalr2.INFO,
    jalr.INFO,
    jr.INFO,
    syscall.INFO,
    mfc0.INFO,
    mtc0.INFO,
    add.INFO,
    addi.INFO,
    addiu.INFO,
    addu.INFO,
    and.INFO,
    andi.INFO,
    lui.INFO,
    nor.INFO,
    or.INFO,
    ori.INFO,
    slt.INFO,
    slti.INFO,
    sltiu.INFO,
    sltu.INFO,
    sub.INFO,
    subu.INFO,
    xor.INFO,
    xori.INFO,
    sll.INFO,
    sllv.INFO,
    sra.INFO,
    srav.INFO,
    srl.INFO,
    srlv.INFO,
    div.INFO,
    divu.INFO,
    mfhi.INFO,
    mflo.INFO,
    mthi.INFO,
    mtlo.INFO,
    mul_signed_words.INFO,
    mult.INFO,
    mul_unsigned_words.INFO,
    multu.INFO,
    instruction.INFO,
    la.INFO
  };

  public Model() {
    super(
        NAME,
        new MetaModel(),
        __MODES,
        __OPS,
        __REGISTERS,
        __MEMORY,
        __VARIABLES,
        __LABELS
        );
  }

  public static void printInformation() {
    final Model model = new Model();

    final MetaModelPrinter metaModelPrinter = new MetaModelPrinter(model.getMetaData());
    metaModelPrinter.printAll();

    final ModelStatePrinter modelStatePrinter = new ModelStatePrinter(model);
    modelStatePrinter.printRegisters();
  }

  public static void main(String[] args) {
    printInformation();
  }
} 