/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.data.TypeId;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;

public final class Shared {
  private Shared() {}
  public static final String PC = "CIA";

  public static final Type BIT = Type.def("BIT", Type.CARD(1));
  public static final Type BYTE = Type.def("BYTE", Type.CARD(8));
  public static final Type HWORD = Type.def("HWORD", Type.CARD(16));
  public static final Type WORD = Type.def("WORD", Type.CARD(32));
  public static final Type DWORD = Type.def("DWORD", Type.CARD(64));
  public static final Type SHORT = Type.def("SHORT", Type.INT(16));
  public static final Type INT = Type.def("INT", Type.INT(32));
  public static final Type LONG = Type.def("LONG", Type.INT(64));

  public static final Memory CIA = Memory.def(Memory.Kind.REG, "CIA", WORD, 0x1);
  public static final Memory BRANCH = Memory.def(Memory.Kind.MEM, "BRANCH", BIT, 0x1);
  public static final Memory BRANCH_INSTRUCTION = Memory.def(Memory.Kind.MEM, "BRANCH_INSTRUCTION", BIT, 0x1);
  public static final Memory SKIPOP = Memory.def(Memory.Kind.MEM, "SKIPOP", BIT, 0x1);
  public static final Memory NEXTPC = Memory.def(Memory.Kind.MEM, "NEXTPC", WORD, 0x1);
  public static final Memory GPR = Memory.def(Memory.Kind.REG, "GPR", WORD, 0x20);
  public static final Memory HI = Memory.def(Memory.Kind.REG, "HI", WORD, 0x1);
  public static final Memory LO = Memory.def(Memory.Kind.REG, "LO", WORD, 0x1);
  public static final Memory CPR = Memory.def(Memory.Kind.REG, "CPR", WORD, 0x100);
  public static final Memory tempCPR = Memory.def(Memory.Kind.VAR, "tempCPR", WORD, 0x1);
  public static final Memory c0_r_number = Memory.def(Memory.Kind.VAR, "c0_r_number", Type.CARD(5), 0x1);
  public static final Memory c0_r_sel = Memory.def(Memory.Kind.VAR, "c0_r_sel", Type.CARD(3), 0x1);
  public static final Memory C0_INDEX = Memory.def(Memory.Kind.REG, "C0_INDEX", WORD, 0x1, CPR.access(0));
  public static final Memory C0_RANDOM = Memory.def(Memory.Kind.REG, "C0_RANDOM", WORD, 0x1, CPR.access(8));
  public static final Memory C0_ENTRY_LO0 = Memory.def(Memory.Kind.REG, "C0_ENTRY_LO0", WORD, 0x1, CPR.access(16));
  public static final Memory C0_ENTRY_LO1 = Memory.def(Memory.Kind.REG, "C0_ENTRY_LO1", WORD, 0x1, CPR.access(24));
  public static final Memory C0_CONTEXT = Memory.def(Memory.Kind.REG, "C0_CONTEXT", WORD, 0x1, CPR.access(32));
  public static final Memory C0_PAGE_MASK = Memory.def(Memory.Kind.REG, "C0_PAGE_MASK", WORD, 0x1, CPR.access(40));
  public static final Memory C0_WIRED = Memory.def(Memory.Kind.REG, "C0_WIRED", WORD, 0x1, CPR.access(48));
  public static final Memory C0_BAD_VADDR = Memory.def(Memory.Kind.REG, "C0_BAD_VADDR", WORD, 0x1, CPR.access(64));
  public static final Memory C0_COUNT = Memory.def(Memory.Kind.REG, "C0_COUNT", WORD, 0x1, CPR.access(72));
  public static final Memory C0_ENTRY_HI = Memory.def(Memory.Kind.REG, "C0_ENTRY_HI", WORD, 0x1, CPR.access(80));
  public static final Memory C0_COMPARE = Memory.def(Memory.Kind.REG, "C0_COMPARE", WORD, 0x1, CPR.access(88));
  public static final Memory C0_STATUS = Memory.def(Memory.Kind.REG, "C0_STATUS", WORD, 0x1, CPR.access(96));
  public static final Memory C0_INTCTL = Memory.def(Memory.Kind.REG, "C0_INTCTL", WORD, 0x1, CPR.access(97));
  public static final Memory C0_SRSCTL = Memory.def(Memory.Kind.REG, "C0_SRSCTL", WORD, 0x1, CPR.access(98));
  public static final Memory C0_CAUSE = Memory.def(Memory.Kind.REG, "C0_CAUSE", WORD, 0x1, CPR.access(104));
  public static final Memory C0_EPC = Memory.def(Memory.Kind.REG, "C0_EPC", WORD, 0x1, CPR.access(112));
  public static final Memory C0_PROCESSOR_ID = Memory.def(Memory.Kind.REG, "C0_PROCESSOR_ID", WORD, 0x1, CPR.access(120));
  public static final Memory C0_CONFIG0 = Memory.def(Memory.Kind.REG, "C0_CONFIG0", WORD, 0x1, CPR.access(128));
  public static final Memory C0_CONFIG0_K0 = Memory.def(Memory.Kind.REG, "C0_CONFIG0_K0", Type.CARD(3), 0x1, C0_CONFIG0.access().bitField(2, 0));
  public static final Memory C0_CONFIG1 = Memory.def(Memory.Kind.REG, "C0_CONFIG1", WORD, 0x1, CPR.access(129));
  public static final Memory C0_CONFIG2 = Memory.def(Memory.Kind.REG, "C0_CONFIG2", WORD, 0x1, CPR.access(130));
  public static final Memory C0_CONFIG3 = Memory.def(Memory.Kind.REG, "C0_CONFIG3", WORD, 0x1, CPR.access(131));
  public static final Memory C0_LOAD_LINKED_ADDRESS = Memory.def(Memory.Kind.REG, "C0_LOAD_LINKED_ADDRESS", WORD, 0x1, CPR.access(136));
  public static final Memory C0_WATCH_LO = Memory.def(Memory.Kind.REG, "C0_WATCH_LO", WORD, 0x1, CPR.access(144));
  public static final Memory C0_WATCH_HI = Memory.def(Memory.Kind.REG, "C0_WATCH_HI", WORD, 0x1, CPR.access(152));
  public static final Memory C0_XCONTEXT = Memory.def(Memory.Kind.REG, "C0_XCONTEXT", WORD, 0x1, CPR.access(160));
  public static final Memory C0_DEBUG = Memory.def(Memory.Kind.REG, "C0_DEBUG", WORD, 0x1, CPR.access(184));
  public static final Memory C0_DEBUG_EPC = Memory.def(Memory.Kind.REG, "C0_DEBUG_EPC", WORD, 0x1, CPR.access(192));
  public static final Memory C0_PERFORMANCE_COUNTER = Memory.def(Memory.Kind.REG, "C0_PERFORMANCE_COUNTER", WORD, 0x1, CPR.access(200));
  public static final Memory C0_ERR_CTRL = Memory.def(Memory.Kind.REG, "C0_ERR_CTRL", WORD, 0x1, CPR.access(208));
  public static final Memory C0_CACHE_ERR = Memory.def(Memory.Kind.REG, "C0_CACHE_ERR", WORD, 0x1, CPR.access(216));
  public static final Memory C0_TAG_DATA_LO = Memory.def(Memory.Kind.REG, "C0_TAG_DATA_LO", WORD, 0x1, CPR.access(224));
  public static final Memory C0_TAG_DATA_HI = Memory.def(Memory.Kind.REG, "C0_TAG_DATA_HI", WORD, 0x1, CPR.access(232));
  public static final Memory C0_ERROR_EPC = Memory.def(Memory.Kind.REG, "C0_ERROR_EPC", WORD, 0x1, CPR.access(240));
  public static final Memory C0_DESAVE = Memory.def(Memory.Kind.REG, "C0_DESAVE", WORD, 0x1, CPR.access(248));
  public static final Memory C0_STATUS_RE = Memory.def(Memory.Kind.REG, "C0_STATUS_RE", BIT, 0x1, C0_STATUS.access().bitField(25, 25));
  public static final Memory C0_STATUS_BEV = Memory.def(Memory.Kind.REG, "C0_STATUS_BEV", BIT, 0x1, C0_STATUS.access().bitField(22, 22));
  public static final Memory C0_STATUS_UX = Memory.def(Memory.Kind.REG, "C0_STATUS_UX", BIT, 0x1, C0_STATUS.access().bitField(5, 5));
  public static final Memory C0_STATUS_KSU = Memory.def(Memory.Kind.REG, "C0_STATUS_KSU", Type.CARD(2), 0x1, C0_STATUS.access().bitField(4, 3));
  public static final Memory C0_STATUS_UM = Memory.def(Memory.Kind.REG, "C0_STATUS_UM", BIT, 0x1, C0_STATUS.access().bitField(4, 4));
  public static final Memory C0_STATUS_R0 = Memory.def(Memory.Kind.REG, "C0_STATUS_R0", BIT, 0x1, C0_STATUS.access().bitField(3, 3));
  public static final Memory C0_STATUS_ERL = Memory.def(Memory.Kind.REG, "C0_STATUS_ERL", BIT, 0x1, C0_STATUS.access().bitField(2, 2));
  public static final Memory C0_STATUS_EXL = Memory.def(Memory.Kind.REG, "C0_STATUS_EXL", BIT, 0x1, C0_STATUS.access().bitField(1, 1));
  public static final Memory C0_STATUS_IE = Memory.def(Memory.Kind.REG, "C0_STATUS_IE", BIT, 0x1, C0_STATUS.access().bitField(0, 0));
  public static final Memory C0_SRSCTL_HSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_HSS", Type.CARD(4), 0x1, C0_STATUS.access().bitField(29, 26));
  public static final Memory C0_SRSCTL_PSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_PSS", Type.CARD(4), 0x1, C0_STATUS.access().bitField(9, 6));
  public static final Memory C0_SRSCTL_CSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_CSS", Type.CARD(4), 0x1, C0_STATUS.access().bitField(3, 0));
  public static final Memory C0_CONFIG1_M = Memory.def(Memory.Kind.REG, "C0_CONFIG1_M", BIT, 0x1, C0_CONFIG3.access().bitField(31, 31));
  public static final Memory C0_CONFIG1_MMUSize = Memory.def(Memory.Kind.REG, "C0_CONFIG1_MMUSize", Type.CARD(6), 0x1, C0_CONFIG3.access().bitField(30, 25));
  public static final Memory C0_CONFIG1_IS = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IS", Type.CARD(3), 0x1, C0_CONFIG3.access().bitField(24, 22));
  public static final Memory C0_CONFIG1_IL = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IL", Type.CARD(3), 0x1, C0_CONFIG3.access().bitField(21, 19));
  public static final Memory C0_CONFIG1_IA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IA", Type.CARD(3), 0x1, C0_CONFIG3.access().bitField(18, 16));
  public static final Memory C0_CONFIG1_DS = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DS", Type.CARD(3), 0x1, C0_CONFIG3.access().bitField(15, 13));
  public static final Memory C0_CONFIG1_DL = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DL", Type.CARD(3), 0x1, C0_CONFIG3.access().bitField(12, 10));
  public static final Memory C0_CONFIG1_DA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DA", Type.CARD(3), 0x1, C0_CONFIG3.access().bitField(9, 7));
  public static final Memory C0_CONFIG1_C2 = Memory.def(Memory.Kind.REG, "C0_CONFIG1_C2", BIT, 0x1, C0_CONFIG3.access().bitField(6, 6));
  public static final Memory C0_CONFIG1_MD = Memory.def(Memory.Kind.REG, "C0_CONFIG1_MD", BIT, 0x1, C0_CONFIG3.access().bitField(5, 5));
  public static final Memory C0_CONFIG1_PC = Memory.def(Memory.Kind.REG, "C0_CONFIG1_PC", BIT, 0x1, C0_CONFIG3.access().bitField(4, 4));
  public static final Memory C0_CONFIG1_WR = Memory.def(Memory.Kind.REG, "C0_CONFIG1_WR", BIT, 0x1, C0_CONFIG3.access().bitField(3, 3));
  public static final Memory C0_CONFIG1_CA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_CA", BIT, 0x1, C0_CONFIG3.access().bitField(2, 2));
  public static final Memory C0_CONFIG1_EP = Memory.def(Memory.Kind.REG, "C0_CONFIG1_EP", BIT, 0x1, C0_CONFIG3.access().bitField(1, 1));
  public static final Memory C0_CONFIG1_FP = Memory.def(Memory.Kind.REG, "C0_CONFIG1_FP", BIT, 0x1, C0_CONFIG3.access().bitField(0, 0));
  public static final Memory C0_CONFIG3_M = Memory.def(Memory.Kind.REG, "C0_CONFIG3_M", BIT, 0x1, C0_CONFIG3.access().bitField(31, 31));
  public static final Memory C0_CONFIG3_SM = Memory.def(Memory.Kind.REG, "C0_CONFIG3_SM", BIT, 0x1, C0_CONFIG3.access().bitField(1, 1));
  public static final Memory C0_CONFIG3_TL = Memory.def(Memory.Kind.REG, "C0_CONFIG3_TL", BIT, 0x1, C0_CONFIG3.access().bitField(0, 0));
  public static final Memory C0_CONFIG3_ISA = Memory.def(Memory.Kind.REG, "C0_CONFIG3_ISA", Type.CARD(2), 0x1, C0_CONFIG3.access().bitField(15, 14));
  public static final Memory C0_DEBUG_DBD = Memory.def(Memory.Kind.REG, "C0_DEBUG_DBD", BIT, 0x1, C0_DEBUG.access().bitField(31, 31));
  public static final Memory C0_DEBUG_DM = Memory.def(Memory.Kind.REG, "C0_DEBUG_DM", BIT, 0x1, C0_DEBUG.access().bitField(30, 30));
  public static final Memory C0_DEBUG_NoDCR = Memory.def(Memory.Kind.REG, "C0_DEBUG_NoDCR", BIT, 0x1, C0_DEBUG.access().bitField(29, 29));
  public static final Memory C0_DEBUG_IEXI = Memory.def(Memory.Kind.REG, "C0_DEBUG_IEXI", BIT, 0x1, C0_DEBUG.access().bitField(20, 20));
  public static final Memory C0_DEBUG_EJTAGver = Memory.def(Memory.Kind.REG, "C0_DEBUG_EJTAGver", Type.CARD(3), 0x1, C0_DEBUG.access().bitField(17, 15));
  public static final Memory C0_DEBUG_DSS = Memory.def(Memory.Kind.REG, "C0_DEBUG_DSS", BIT, 0x1, C0_DEBUG.access().bitField(0, 0));
  public static final Memory MEM = Memory.def(Memory.Kind.MEM, "MEM", WORD, 0x7ff);
  public static final Memory hint = Memory.def(Memory.Kind.REG, "hint", Type.CARD(5), 0x1);
  public static final Memory ISAMode = Memory.def(Memory.Kind.REG, "ISAMode", BIT, 0x1);
  public static final Memory temp_bit = Memory.def(Memory.Kind.VAR, "temp_bit", BIT, 0x1);
  public static final Memory temp6 = Memory.def(Memory.Kind.VAR, "temp6", Type.CARD(6), 0x1);
  public static final Memory temp = Memory.def(Memory.Kind.VAR, "temp", WORD, 0x1);
  public static final Memory temp0 = Memory.def(Memory.Kind.VAR, "temp0", WORD, 0x1);
  public static final Memory temp1 = Memory.def(Memory.Kind.VAR, "temp1", WORD, 0x1);
  public static final Memory temp2 = Memory.def(Memory.Kind.VAR, "temp2", WORD, 0x1);
  public static final Memory temp3 = Memory.def(Memory.Kind.VAR, "temp3", WORD, 0x1);
  public static final Memory temp64 = Memory.def(Memory.Kind.VAR, "temp64", DWORD, 0x1);
  public static final Memory temp64_1 = Memory.def(Memory.Kind.VAR, "temp64_1", DWORD, 0x1);
  public static final Memory temp64_2 = Memory.def(Memory.Kind.VAR, "temp64_2", DWORD, 0x1);
  public static final Memory tempI = Memory.def(Memory.Kind.VAR, "tempI", INT, 0x1);
  public static final Memory temp28 = Memory.def(Memory.Kind.VAR, "temp28", Type.CARD(28), 0x1);
  public static final Memory temp33 = Memory.def(Memory.Kind.VAR, "temp33", Type.CARD(33), 0x1);
  public static final Memory temp65 = Memory.def(Memory.Kind.VAR, "temp65", Type.CARD(65), 0x1);
  public static final Memory op_encoding = Memory.def(Memory.Kind.VAR, "op_encoding", Type.CARD(6), 0x1);
  public static final Memory temp_address = Memory.def(Memory.Kind.VAR, "temp_address", WORD, 0x1);
  public static final Memory temp_byte_offset = Memory.def(Memory.Kind.VAR, "temp_byte_offset", Type.CARD(2), 0x1);
  public static final Memory temp_bit_offset = Memory.def(Memory.Kind.VAR, "temp_bit_offset", Type.CARD(6), 0x1);
  public static final Memory load_temp32 = Memory.def(Memory.Kind.VAR, "load_temp32", WORD, 0x1);
  public static final Memory temp_address_load = Memory.def(Memory.Kind.VAR, "temp_address_load", WORD, 0x1);
  public static final Memory load_address_error = Memory.def(Memory.Kind.VAR, "load_address_error", WORD, 0x1);
  public static final Memory store_address_error = Memory.def(Memory.Kind.VAR, "store_address_error", WORD, 0x1);
  public static final Memory is_delay_slot = Memory.def(Memory.Kind.VAR, "is_delay_slot", BIT, 0x1);
  public static final Memory last_branch_instruction = Memory.def(Memory.Kind.VAR, "last_branch_instruction", BIT, 0x1);
  public static final Memory jump_address = Memory.def(Memory.Kind.VAR, "jump_address", WORD, 0x1);

  public static final Memory[] __REGISTERS = {CIA, GPR, HI, LO, CPR, C0_INDEX, C0_RANDOM, C0_ENTRY_LO0, C0_ENTRY_LO1, C0_CONTEXT, C0_PAGE_MASK, C0_WIRED, C0_BAD_VADDR, C0_COUNT, C0_ENTRY_HI, C0_COMPARE, C0_STATUS, C0_INTCTL, C0_SRSCTL, C0_CAUSE, C0_EPC, C0_PROCESSOR_ID, C0_CONFIG0, C0_CONFIG0_K0, C0_CONFIG1, C0_CONFIG2, C0_CONFIG3, C0_LOAD_LINKED_ADDRESS, C0_WATCH_LO, C0_WATCH_HI, C0_XCONTEXT, C0_DEBUG, C0_DEBUG_EPC, C0_PERFORMANCE_COUNTER, C0_ERR_CTRL, C0_CACHE_ERR, C0_TAG_DATA_LO, C0_TAG_DATA_HI, C0_ERROR_EPC, C0_DESAVE, C0_STATUS_RE, C0_STATUS_BEV, C0_STATUS_UX, C0_STATUS_KSU, C0_STATUS_UM, C0_STATUS_R0, C0_STATUS_ERL, C0_STATUS_EXL, C0_STATUS_IE, C0_SRSCTL_HSS, C0_SRSCTL_PSS, C0_SRSCTL_CSS, C0_CONFIG1_M, C0_CONFIG1_MMUSize, C0_CONFIG1_IS, C0_CONFIG1_IL, C0_CONFIG1_IA, C0_CONFIG1_DS, C0_CONFIG1_DL, C0_CONFIG1_DA, C0_CONFIG1_C2, C0_CONFIG1_MD, C0_CONFIG1_PC, C0_CONFIG1_WR, C0_CONFIG1_CA, C0_CONFIG1_EP, C0_CONFIG1_FP, C0_CONFIG3_M, C0_CONFIG3_SM, C0_CONFIG3_TL, C0_CONFIG3_ISA, C0_DEBUG_DBD, C0_DEBUG_DM, C0_DEBUG_NoDCR, C0_DEBUG_IEXI, C0_DEBUG_EJTAGver, C0_DEBUG_DSS, hint, ISAMode};
  public static final Memory[] __MEMORY = {BRANCH, BRANCH_INSTRUCTION, SKIPOP, NEXTPC, MEM};
  public static final Memory[] __VARIABLES = {tempCPR, c0_r_number, c0_r_sel, temp_bit, temp6, temp, temp0, temp1, temp2, temp3, temp64, temp64_1, temp64_2, tempI, temp28, temp33, temp65, op_encoding, temp_address, temp_byte_offset, temp_bit_offset, load_temp32, temp_address_load, load_address_error, store_address_error, is_delay_slot, last_branch_instruction, jump_address};
  public static final Label[] __LABELS = {new Label("PC", CIA, 0)};
} 