/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.metadata;

import static ru.ispras.microtesk.model.plasma.Shared.*;

import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.metadata.MetaModelBuilder;

/**
 * The {@code MetaModel} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModel extends MetaModelBuilder {
  public MetaModel() {
    addRegister("CIA", WORD, 1);
    addRegister("GPR", WORD, 32);
    addRegister("HI", WORD, 1);
    addRegister("LO", WORD, 1);
    addRegister("CPR", WORD, 256);
    addRegister("C0_INDEX", WORD, 1);
    addRegister("C0_RANDOM", WORD, 1);
    addRegister("C0_ENTRY_LO0", WORD, 1);
    addRegister("C0_ENTRY_LO1", WORD, 1);
    addRegister("C0_CONTEXT", WORD, 1);
    addRegister("C0_PAGE_MASK", WORD, 1);
    addRegister("C0_WIRED", WORD, 1);
    addRegister("C0_BAD_VADDR", WORD, 1);
    addRegister("C0_COUNT", WORD, 1);
    addRegister("C0_ENTRY_HI", WORD, 1);
    addRegister("C0_COMPARE", WORD, 1);
    addRegister("C0_STATUS", WORD, 1);
    addRegister("C0_INTCTL", WORD, 1);
    addRegister("C0_SRSCTL", WORD, 1);
    addRegister("C0_CAUSE", WORD, 1);
    addRegister("C0_EPC", WORD, 1);
    addRegister("C0_PROCESSOR_ID", WORD, 1);
    addRegister("C0_CONFIG0", WORD, 1);
    addRegister("C0_CONFIG0_K0", Type.CARD(3), 1);
    addRegister("C0_CONFIG1", WORD, 1);
    addRegister("C0_CONFIG2", WORD, 1);
    addRegister("C0_CONFIG3", WORD, 1);
    addRegister("C0_LOAD_LINKED_ADDRESS", WORD, 1);
    addRegister("C0_WATCH_LO", WORD, 1);
    addRegister("C0_WATCH_HI", WORD, 1);
    addRegister("C0_XCONTEXT", WORD, 1);
    addRegister("C0_DEBUG", WORD, 1);
    addRegister("C0_DEBUG_EPC", WORD, 1);
    addRegister("C0_PERFORMANCE_COUNTER", WORD, 1);
    addRegister("C0_ERR_CTRL", WORD, 1);
    addRegister("C0_CACHE_ERR", WORD, 1);
    addRegister("C0_TAG_DATA_LO", WORD, 1);
    addRegister("C0_TAG_DATA_HI", WORD, 1);
    addRegister("C0_ERROR_EPC", WORD, 1);
    addRegister("C0_DESAVE", WORD, 1);
    addRegister("C0_STATUS_RE", BIT, 1);
    addRegister("C0_STATUS_BEV", BIT, 1);
    addRegister("C0_STATUS_UX", BIT, 1);
    addRegister("C0_STATUS_KSU", Type.CARD(2), 1);
    addRegister("C0_STATUS_UM", BIT, 1);
    addRegister("C0_STATUS_R0", BIT, 1);
    addRegister("C0_STATUS_ERL", BIT, 1);
    addRegister("C0_STATUS_EXL", BIT, 1);
    addRegister("C0_STATUS_IE", BIT, 1);
    addRegister("C0_SRSCTL_HSS", Type.CARD(4), 1);
    addRegister("C0_SRSCTL_PSS", Type.CARD(4), 1);
    addRegister("C0_SRSCTL_CSS", Type.CARD(4), 1);
    addRegister("C0_CONFIG1_M", BIT, 1);
    addRegister("C0_CONFIG1_MMUSize", Type.CARD(6), 1);
    addRegister("C0_CONFIG1_IS", Type.CARD(3), 1);
    addRegister("C0_CONFIG1_IL", Type.CARD(3), 1);
    addRegister("C0_CONFIG1_IA", Type.CARD(3), 1);
    addRegister("C0_CONFIG1_DS", Type.CARD(3), 1);
    addRegister("C0_CONFIG1_DL", Type.CARD(3), 1);
    addRegister("C0_CONFIG1_DA", Type.CARD(3), 1);
    addRegister("C0_CONFIG1_C2", BIT, 1);
    addRegister("C0_CONFIG1_MD", BIT, 1);
    addRegister("C0_CONFIG1_PC", BIT, 1);
    addRegister("C0_CONFIG1_WR", BIT, 1);
    addRegister("C0_CONFIG1_CA", BIT, 1);
    addRegister("C0_CONFIG1_EP", BIT, 1);
    addRegister("C0_CONFIG1_FP", BIT, 1);
    addRegister("C0_CONFIG3_M", BIT, 1);
    addRegister("C0_CONFIG3_SM", BIT, 1);
    addRegister("C0_CONFIG3_TL", BIT, 1);
    addRegister("C0_CONFIG3_ISA", Type.CARD(2), 1);
    addRegister("C0_DEBUG_DBD", BIT, 1);
    addRegister("C0_DEBUG_DM", BIT, 1);
    addRegister("C0_DEBUG_NoDCR", BIT, 1);
    addRegister("C0_DEBUG_IEXI", BIT, 1);
    addRegister("C0_DEBUG_EJTAGver", Type.CARD(3), 1);
    addRegister("C0_DEBUG_DSS", BIT, 1);
    addRegister("hint", Type.CARD(5), 1);
    addRegister("ISAMode", BIT, 1);

    addMemory("BRANCH", BIT, 0x1);
    addMemory("BRANCH_INSTRUCTION", BIT, 0x1);
    addMemory("SKIPOP", BIT, 0x1);
    addMemory("NEXTPC", WORD, 0x1);
    addMemory("MEM", WORD, 0x7ff);

    addMode(R.get());
    addMode(CPRGET.get());
    addMode(CPRSET.get());
    addMode(C0_R.get());

    addOperation(nop.get());
    addOperation(PlasmaNopOp.get());
    addOperation(mips32_load.get());
    addOperation(lb.get());
    addOperation(lbu.get());
    addOperation(lh.get());
    addOperation(lhu.get());
    addOperation(lw.get());
    addOperation(mips32_store.get());
    addOperation(sb.get());
    addOperation(sh.get());
    addOperation(sw.get());
    addOperation(wait.get());
    addOperation(PlasmaMmuOp.get());
    addOperation(beq.get());
    addOperation(bgez.get());
    addOperation(bgezal.get());
    addOperation(bgtz.get());
    addOperation(blez.get());
    addOperation(bltz.get());
    addOperation(bltzal.get());
    addOperation(bne.get());
    addOperation(break_ins.get());
    addOperation(j.get());
    addOperation(jal.get());
    addOperation(jalr2.get());
    addOperation(jalr.get());
    addOperation(jr.get());
    addOperation(syscall.get());
    addOperation(mfc0.get());
    addOperation(mtc0.get());
    addOperation(PlasmaBpuOp.get());
    addOperation(add.get());
    addOperation(addi.get());
    addOperation(addiu.get());
    addOperation(addu.get());
    addOperation(and.get());
    addOperation(andi.get());
    addOperation(lui.get());
    addOperation(nor.get());
    addOperation(or.get());
    addOperation(ori.get());
    addOperation(slt.get());
    addOperation(slti.get());
    addOperation(sltiu.get());
    addOperation(sltu.get());
    addOperation(sub.get());
    addOperation(subu.get());
    addOperation(xor.get());
    addOperation(xori.get());
    addOperation(PlasmaArithmeticOp.get());
    addOperation(sll.get());
    addOperation(sllv.get());
    addOperation(sra.get());
    addOperation(srav.get());
    addOperation(srl.get());
    addOperation(srlv.get());
    addOperation(PlasmaShifterOp.get());
    addOperation(div.get());
    addOperation(divu.get());
    addOperation(mfhi.get());
    addOperation(mflo.get());
    addOperation(mthi.get());
    addOperation(mtlo.get());
    addOperation(mul_signed_words.get());
    addOperation(mult.get());
    addOperation(mul_unsigned_words.get());
    addOperation(multu.get());
    addOperation(PlasmaMultiplyOp.get());
    addOperation(PlasmaAluOp.get());
    addOperation(Op.get());
    addOperation(instruction.get());
    addOperation(la.get());
  }
}
