/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class C0_R extends AddressingMode {
  public static final String NAME = "C0_R";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          C0_R.class,
          "C0_R",
          WORD,
          new ArgumentDecls()
              .add("r", Type.CARD(5))
              .add("s", Type.CARD(3))
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate r = (Immediate) getArgument("r", args);
      final Immediate s = (Immediate) getArgument("s", args);
      return new C0_R(r, s);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate r;
  public final Immediate s;

  public C0_R(final Immediate r, final Immediate s) {
    this.r = r;
    this.s = s;
  }

  @Override
  public String syntax() {
    return String.format("$%d, %d", r.access().load().bigIntegerValue(), s.access().load().bigIntegerValue());
  }

  @Override
  public void action() {
    c0_r_number.access().store(r.access().load());
    c0_r_sel.access().store(s.access().load());
  }

  @Override
  public Location access() {
    return CPR.access(Data.valueOf(Type.CARD(8), 0x8).multiply(Data.zeroExtend(Type.CARD(8), r.access().load())).add(Data.zeroExtend(Type.CARD(8), s.access().load()))).setName(syntax());
  }
}