/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class CPRSET extends AddressingMode {
  public static final String NAME = "CPRSET";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          CPRSET.class,
          "CPRSET",
          null,
          new ArgumentDecls()
              .add("i", Type.CARD(8))
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new CPRSET(i);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate i;

  public CPRSET(final Immediate i) {
    this.i = i;
  }

  @Override
  public void action() {
    CPR.access(i.access().load()).store(tempCPR.access().load());
  }

}