/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class addi extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         addi.class,
         "addi",
         new ArgumentDecls()
             .add("rt", R.INFO)
             .add("rs", R.INFO)
             .add("immediate", SHORT),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate immediate = (Immediate) getArgument("immediate", args);

      return new addi(rt, rs, immediate);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "addi",
          new ArgumentDecls()
              .add("rt", R.INFO)
              .add("rs", R.INFO)
              .add("immediate", SHORT)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate immediate = (Immediate) getArgument("immediate", args);

      return new instruction(
        new addi(
          rt,
          rs,
          immediate
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rt;
  public final R rs;
  public final Immediate immediate;

  public addi(final R rt, final R rs, final Immediate immediate) {
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rs);
    assert SHORT.equals(immediate.getType());
    this.rt = rt;
    this.rs = rs;
    this.immediate = immediate;
  }

  @Override
  public String syntax() {
    return String.format("addi %s, %s, %d", rt.syntax(), rs.syntax(), immediate.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("001000%5s%5s%16s", rt.image(), rs.image(), immediate.access().load().toString());
  }

  @Override
  public void action() {
    temp33.access().store(Location.concat(rs.access().bitField(31, 0), rs.access().bitField(31, 31)).load().add(Data.signExtend(Type.CARD(33), immediate.access().load())));
    if (!temp33.access().bitField(32, 32).load().equals(temp33.access().bitField(31, 31).load())) {
      Execution.exception("IntegerOverflow");
    } else {
      rt.access().store(temp33.access().bitField(31, 0).load());
    }
  }
}