/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class bgez extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         bgez.class,
         "bgez",
         new ArgumentDecls()
             .add("rs", R.INFO)
             .add("offset", SHORT),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new bgez(rs, offset);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "bgez",
          new ArgumentDecls()
              .add("rs", R.INFO)
              .add("offset", SHORT)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new instruction(
        new bgez(
          rs,
          offset
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rs;
  public final Immediate offset;

  public bgez(final R rs, final Immediate offset) {
    assert R.INFO.isSupported(rs);
    assert SHORT.equals(offset.getType());
    this.rs = rs;
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("bgez %s, <label>%d", rs.syntax(), offset.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("000001%5s00001%16s", rs.image(), offset.access().load().toString());
  }

  @Override
  public void action() {
    BRANCH_INSTRUCTION.access().store(Data.valueOf(BIT, 0x1));
    if ((Data.cast(INT, rs.access().load()).compareTo(Data.valueOf(INT, 0x0)) >= 0)) {
      BRANCH.access().store(Data.valueOf(BIT, 0x1));
      NEXTPC.access().store(CIA.access().load().add(Data.signExtend(WORD, offset.access().load()).shiftLeft(Data.valueOf(WORD, 0x2))));
    }
  }
}