/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class div extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         div.class,
         "div",
         new ArgumentDecls()
             .add("rs", R.INFO)
             .add("rt", R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new div(rs, rt);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "div",
          new ArgumentDecls()
              .add("rs", R.INFO)
              .add("rt", R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new instruction(
        new div(
          rs,
          rt
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rs;
  public final R rt;

  public div(final R rs, final R rt) {
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);
    this.rs = rs;
    this.rt = rt;
  }

  @Override
  public String syntax() {
    return String.format("div %s, %s", rs.syntax(), rt.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%5s%5s0000000000011010", rs.image(), rt.image());
  }

  @Override
  public void action() {
    LO.access().store(Data.cast(WORD, Data.cast(INT, rs.access().load()).divide(Data.cast(INT, rt.access().load()))));
    HI.access().store(Data.cast(WORD, Data.cast(INT, rs.access().load()).mod(Data.cast(INT, rt.access().load()))));
  }
}