/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class instruction extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         instruction.class,
         "instruction",
         new ArgumentDecls()
             .add("operation", Op.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Operation operation = (Operation) getArgument("operation", args);

      return new instruction(operation);
    }
  }
  public static final IInfo INFO = new Info();

  public final Operation operation;

  public instruction(final Operation operation) {
    assert Op.INFO.isSupported(operation);
    this.operation = operation;
  }

  @Override
  public String syntax() {
    return operation.syntax();
  }

  @Override
  public String image() {
    return operation.image();
  }

  @Override
  public void action() {
    GPR.access(0).store(Data.valueOf(WORD, 0x0));
    last_branch_instruction.access().store(BRANCH_INSTRUCTION.access().load());
    is_delay_slot.access().store(BRANCH.access().load());
    jump_address.access().store(NEXTPC.access().load());
    BRANCH_INSTRUCTION.access().store(Data.valueOf(BIT, 0x0));
    BRANCH.access().store(Data.valueOf(BIT, 0x0));
    NEXTPC.access().store(Data.valueOf(WORD, 0x0));
    if (SKIPOP.access().load().equals(Data.valueOf(BIT, 0x0))) {
      operation.execute();
    } else {
      SKIPOP.access().store(Data.valueOf(BIT, 0x0));
    }
    if (BRANCH_INSTRUCTION.access().load().equals(Data.valueOf(BIT, 0x1)) && last_branch_instruction.access().load().equals(Data.valueOf(BIT, 0x1))) {
      Execution.unpredicted();
    }
    if (is_delay_slot.access().load().equals(Data.valueOf(BIT, 0x1))) {
      CIA.access().store(jump_address.access().load());
    } else {
      CIA.access().store(CIA.access().load().add(Data.valueOf(WORD, 0x4)));
    }
  }
}