/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class j extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         j.class,
         "j",
         new ArgumentDecls()
             .add("instr_index", Type.CARD(26)),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate instr_index = (Immediate) getArgument("instr_index", args);

      return new j(instr_index);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "j",
          new ArgumentDecls()
              .add("instr_index", Type.CARD(26))
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate instr_index = (Immediate) getArgument("instr_index", args);

      return new instruction(
        new j(
          instr_index
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate instr_index;

  public j(final Immediate instr_index) {
    assert Type.CARD(26).equals(instr_index.getType());
    this.instr_index = instr_index;
  }

  @Override
  public String syntax() {
    return String.format("j <label>%d", instr_index.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("000010%26s", instr_index.access().load().toString());
  }

  @Override
  public void action() {
    BRANCH_INSTRUCTION.access().store(Data.valueOf(BIT, 0x1));
    temp28.access().store(Data.zeroExtend(Type.CARD(28), instr_index.access().load()).shiftLeft(Data.valueOf(Type.CARD(28), 0x2)));
    BRANCH.access().store(Data.valueOf(BIT, 0x1));
    NEXTPC.access().store(Location.concat(temp28.access(), CIA.access().bitField(31, 28)).load());
  }
}