/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class jalr extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         jalr.class,
         "jalr",
         new ArgumentDecls()
             .add("rs", R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);

      return new jalr(rs);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "jalr",
          new ArgumentDecls()
              .add("rs", R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);

      return new instruction(
        new jalr(
          rs
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rs;

  public jalr(final R rs) {
    assert R.INFO.isSupported(rs);
    this.rs = rs;
  }

  @Override
  public String syntax() {
    return String.format("jalr %s", rs.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%5s0000011111%5s001001", rs.image(), hint.access().load().toString());
  }

  @Override
  public void action() {
    new jalr2(new R(new Immediate(Data.valueOf(Type.CARD(5), 0x1f))), rs).execute();
  }
}