/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class jr extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         jr.class,
         "jr",
         new ArgumentDecls()
             .add("rs", R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);

      return new jr(rs);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "jr",
          new ArgumentDecls()
              .add("rs", R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);

      return new instruction(
        new jr(
          rs
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rs;

  public jr(final R rs) {
    assert R.INFO.isSupported(rs);
    this.rs = rs;
  }

  @Override
  public String syntax() {
    return String.format("jr %s", rs.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%5s0000000000%5s001000", rs.image(), hint.access().load().toString());
  }

  @Override
  public void action() {
    BRANCH_INSTRUCTION.access().store(Data.valueOf(BIT, 0x1));
    BRANCH.access().store(Data.valueOf(BIT, 0x1));
    if (C0_CONFIG1_CA.access().load().equals(Data.valueOf(BIT, 0x0))) {
      NEXTPC.access().store(rs.access().load());
    } else {
      temp_bit.access().store(Data.valueOf(BIT, 0x0));
      NEXTPC.access().store(Location.concat(temp_bit.access().bitField(0, 0), rs.access().bitField(31, 1)).load());
      ISAMode.access().store(rs.access().bitField(0, 0).load());
    }
  }
}