/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class mfc0 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mfc0.class,
         "mfc0",
         new ArgumentDecls()
             .add("rt", R.INFO)
             .add("rd", C0_R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final C0_R rd = (C0_R) getArgument("rd", args);

      return new mfc0(rt, rd);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "mfc0",
          new ArgumentDecls()
              .add("rt", R.INFO)
              .add("rd", C0_R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final C0_R rd = (C0_R) getArgument("rd", args);

      return new instruction(
        new mfc0(
          rt,
          rd
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rt;
  public final C0_R rd;

  public mfc0(final R rt, final C0_R rd) {
    assert R.INFO.isSupported(rt);
    assert C0_R.INFO.isSupported(rd);
    this.rt = rt;
    this.rd = rd;
  }

  public void init() {
    rd.execute();
  }

  @Override
  public String syntax() {
    init();
    return String.format("mfc0 %s, %s", rt.syntax(), rd.syntax());
  }

  @Override
  public String image() {
    init();
    return String.format("01000000000%5s%5s00000000%3s", rt.image(), c0_r_number.access().load().toString(), c0_r_sel.access().load().toString());
  }

  @Override
  public void action() {
    init();
    rt.access().store(rd.access().load());
  }
}