/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class mfhi extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mfhi.class,
         "mfhi",
         new ArgumentDecls()
             .add("rd", R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);

      return new mfhi(rd);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "mfhi",
          new ArgumentDecls()
              .add("rd", R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);

      return new instruction(
        new mfhi(
          rd
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rd;

  public mfhi(final R rd) {
    assert R.INFO.isSupported(rd);
    this.rd = rd;
  }

  @Override
  public String syntax() {
    return String.format("mfhi %s", rd.syntax());
  }

  @Override
  public String image() {
    return String.format("0000000000000000%5s00000010000", rd.image());
  }

  @Override
  public void action() {
    rd.access().store(HI.access().load());
  }
}