/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class mips32_store extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mips32_store.class,
         "mips32_store",
         new ArgumentDecls()
             .add("store_op", Type.CARD(3))
             .add("rt", R.INFO)
             .add("offset", SHORT)
             .add("base", R.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate store_op = (Immediate) getArgument("store_op", args);
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new mips32_store(store_op, rt, offset, base);
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate store_op;
  public final R rt;
  public final Immediate offset;
  public final R base;

  public mips32_store(final Immediate store_op, final R rt, final Immediate offset, final R base) {
    assert Type.CARD(3).equals(store_op.getType());
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    assert R.INFO.isSupported(base);
    this.store_op = store_op;
    this.rt = rt;
    this.offset = offset;
    this.base = base;
  }

  @Override
  public void action() {
    temp_address.access().store(base.access().load().add(Data.signExtend(WORD, offset.access().load())));
    temp0.access().store(MEM.access(temp_address.access().load().shiftRight(Data.valueOf(WORD, 0x2))).load());
    temp_byte_offset.access().store(temp_address.access().bitField(1, 0).load().xor(Data.valueOf(Type.CARD(2), 0x0)));
    store_address_error.access().store(Data.zeroExtend(WORD, temp_byte_offset.access().bitField(1, 0).load()).mod(Data.zeroExtend(WORD, store_op.access().load())));
    if ((store_address_error.access().load().compareTo(Data.valueOf(WORD, 0x0)) > 0)) {
      C0_EPC.access().store(CIA.access().load());
      Execution.exception("AddressError: mips32_store");
      Execution.trace("type = 0x%x", store_op.access().load().bigIntegerValue(false));
    }
    temp.access().store(Data.valueOf(WORD, 0x8).multiply(Data.zeroExtend(WORD, temp_byte_offset.access().bitField(1, 0).load())));
    temp1.access().store(Data.valueOf(WORD, 0xffffffffL));
    temp1.access().store(temp1.access().load().shiftRight(Data.valueOf(HWORD, 0x40).subtract(Data.valueOf(HWORD, 0x8).multiply(Data.zeroExtend(HWORD, store_op.access().load())))));
    temp1.access().store(temp1.access().load().shiftLeft(temp.access().load()));
    temp2.access().store(rt.access().bitField(31, 0).load().shiftLeft(temp.access().load()));
    temp2.access().store(temp2.access().load().and(temp1.access().load()));
    temp1.access().store(temp1.access().load().not());
    temp1.access().store(temp1.access().load().and(temp0.access().load()));
    temp3.access().store(temp2.access().load().or(temp1.access().load()));
    MEM.access(temp_address.access().load().shiftRight(Data.valueOf(WORD, 0x2))).store(temp3.access().load());
  }
}