/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class mtlo extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mtlo.class,
         "mtlo",
         new ArgumentDecls()
             .add("rs", R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);

      return new mtlo(rs);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "mtlo",
          new ArgumentDecls()
              .add("rs", R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rs = (R) getArgument("rs", args);

      return new instruction(
        new mtlo(
          rs
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rs;

  public mtlo(final R rs) {
    assert R.INFO.isSupported(rs);
    this.rs = rs;
  }

  @Override
  public String syntax() {
    return String.format("mtlo %s", rs.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%5s000000000000000010011", rs.image());
  }

  @Override
  public void action() {
    LO.access().store(rs.access().load());
  }
}