/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class mul_signed_words extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mul_signed_words.class,
         "mul_signed_words",
         new ArgumentDecls()
             .add("temp_a", WORD)
             .add("temp_b", WORD));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate temp_a = (Immediate) getArgument("temp_a", args);
      final Immediate temp_b = (Immediate) getArgument("temp_b", args);

      return new mul_signed_words(temp_a, temp_b);
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate temp_a;
  public final Immediate temp_b;

  public mul_signed_words(final Immediate temp_a, final Immediate temp_b) {
    assert WORD.equals(temp_a.getType());
    assert WORD.equals(temp_b.getType());
    this.temp_a = temp_a;
    this.temp_b = temp_b;
  }

  @Override
  public void action() {
    temp64_1.access().store(Data.signExtend(DWORD, temp_a.access().bitField(31, 0).load()));
    temp64_2.access().store(Data.signExtend(DWORD, temp_b.access().bitField(31, 0).load()));
    temp64.access().store(Data.cast(LONG, temp64_1.access().load()).multiply(Data.cast(LONG, temp64_2.access().load())));
  }
}