/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class nop extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         nop.class,
         "nop",
         new ArgumentDecls(),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new nop();
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "nop",
          new ArgumentDecls()
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new instruction(
        new nop()
      );
    }
  }
  public static final IInfo INFO = new Info();

  public nop() {
  }

  @Override
  public String syntax() {
    return "nop";
  }

  @Override
  public String image() {
    return "00000000000000000000000000000000";
  }

  @Override
  public void action() {
  }
}