/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class or extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         or.class,
         "or",
         new ArgumentDecls()
             .add("rd", R.INFO)
             .add("rs", R.INFO)
             .add("rt", R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new or(rd, rs, rt);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "or",
          new ArgumentDecls()
              .add("rd", R.INFO)
              .add("rs", R.INFO)
              .add("rt", R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new instruction(
        new or(
          rd,
          rs,
          rt
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rd;
  public final R rs;
  public final R rt;

  public or(final R rd, final R rs, final R rt) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);
    this.rd = rd;
    this.rs = rs;
    this.rt = rt;
  }

  @Override
  public String syntax() {
    return String.format("or %s, %s, %s", rd.syntax(), rs.syntax(), rt.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%5s%5s%5s00000100101", rs.image(), rt.image(), rd.image());
  }

  @Override
  public void action() {
    rd.access().store(rs.access().load().or(rt.access().load()));
  }
}