/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class sh extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         sh.class,
         "sh",
         new ArgumentDecls()
             .add("rt", R.INFO)
             .add("offset", SHORT)
             .add("base", R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new sh(rt, offset, base);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "sh",
          new ArgumentDecls()
              .add("rt", R.INFO)
              .add("offset", SHORT)
              .add("base", R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new instruction(
        new sh(
          rt,
          offset,
          base
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rt;
  public final Immediate offset;
  public final R base;

  public sh(final R rt, final Immediate offset, final R base) {
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    assert R.INFO.isSupported(base);
    this.rt = rt;
    this.offset = offset;
    this.base = base;
  }

  @Override
  public String syntax() {
    return String.format("sh %s, %d(%s)", rt.syntax(), offset.access().load().bigIntegerValue(), base.syntax());
  }

  @Override
  public String image() {
    return String.format("101001%5s%5s%16s", base.image(), rt.image(), offset.access().load().toString());
  }

  @Override
  public void action() {
    new mips32_store(new Immediate(Data.valueOf(Type.CARD(3), 0x2)), rt, offset, base).execute();
  }
}