/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class sltiu extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         sltiu.class,
         "sltiu",
         new ArgumentDecls()
             .add("rt", R.INFO)
             .add("rs", R.INFO)
             .add("immediate", SHORT),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate immediate = (Immediate) getArgument("immediate", args);

      return new sltiu(rt, rs, immediate);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "sltiu",
          new ArgumentDecls()
              .add("rt", R.INFO)
              .add("rs", R.INFO)
              .add("immediate", SHORT)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate immediate = (Immediate) getArgument("immediate", args);

      return new instruction(
        new sltiu(
          rt,
          rs,
          immediate
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rt;
  public final R rs;
  public final Immediate immediate;

  public sltiu(final R rt, final R rs, final Immediate immediate) {
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rs);
    assert SHORT.equals(immediate.getType());
    this.rt = rt;
    this.rs = rs;
    this.immediate = immediate;
  }

  @Override
  public String syntax() {
    return String.format("sltiu %s, %s, 0x%x", rt.syntax(), rs.syntax(), immediate.access().load().bigIntegerValue(false));
  }

  @Override
  public String image() {
    return String.format("001011%5s%5s%16s", rs.image(), rt.image(), immediate.access().load().toString());
  }

  @Override
  public void action() {
    if ((rs.access().load().compareTo(Data.signExtend(WORD, immediate.access().load())) < 0)) {
      rt.access().store(Data.valueOf(WORD, 0x1));
    } else {
      rt.access().store(Data.valueOf(WORD, 0x0));
    }
  }
}