/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.plasma.mode.*;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class srav extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         srav.class,
         "srav",
         new ArgumentDecls()
             .add("rd", R.INFO)
             .add("rt", R.INFO)
             .add("rs", R.INFO),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);

      return new srav(rd, rt, rs);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "srav",
          new ArgumentDecls()
              .add("rd", R.INFO)
              .add("rt", R.INFO)
              .add("rs", R.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);

      return new instruction(
        new srav(
          rd,
          rt,
          rs
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R rd;
  public final R rt;
  public final R rs;

  public srav(final R rd, final R rt, final R rs) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rs);
    this.rd = rd;
    this.rt = rt;
    this.rs = rs;
  }

  @Override
  public String syntax() {
    return String.format("srav %s, %s, %s", rd.syntax(), rt.syntax(), rs.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%5s%5s%5s00000000111", rs.image(), rt.image(), rd.image());
  }

  @Override
  public void action() {
    rd.access().store(rt.access().load().shiftRight(Data.zeroExtend(WORD, rs.access().bitField(4, 0).load())));
  }
}