/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.plasma.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.plasma.Shared.*;

public final class wait extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         wait.class,
         "wait",
         new ArgumentDecls()
             .add("code", Type.CARD(19)),
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate code = (Immediate) getArgument("code", args);

      return new wait(code);
    }
  }
  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "wait",
          new ArgumentDecls()
              .add("code", Type.CARD(19))
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate code = (Immediate) getArgument("code", args);

      return new instruction(
        new wait(
          code
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate code;

  public wait(final Immediate code) {
    assert Type.CARD(19).equals(code.getType());
    this.code = code;
  }

  @Override
  public String syntax() {
    return String.format("wait 0x%x", code.access().load().bigIntegerValue(false));
  }

  @Override
  public String image() {
    return String.format("0100001%19s100000", code.access().load().toString());
  }

  @Override
  public void action() {
  }
}