/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.Shared.*;

public final class B extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         B.class,
         "B",
         new ArgumentDecls()
             .add("offset", SHORT));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new B(offset);
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate offset;

  public B(final Immediate offset) {
    assert SHORT.equals(offset.getType());
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("B <label>%d", offset.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("0001000000000000%s", offset.access().load().toString());
  }

  @Override
  public void action() {
    BRANCH.access().store(Data.valueOf(BIT, 0x1));
    JMPADDR.access().store(NIA.access().load().add(Data.signExtend(WORD, offset.access().load()).shiftLeft(Data.valueOf(WORD, 0x3))));
  }
}