/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.Shared.*;

public final class C_EQ_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         C_EQ_S.class,
         "C_EQ_S",
         new ArgumentDecls()
             .add("ft", F.INFO)
             .add("fs", F.INFO)
             .add("cc", COND_CODE));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final F ft = (F) getArgument("ft", args);
      final F fs = (F) getArgument("fs", args);
      final Immediate cc = (Immediate) getArgument("cc", args);

      return new C_EQ_S(ft, fs, cc);
    }
  }
  public static final IInfo INFO = new Info();

  public final F ft;
  public final F fs;
  public final Immediate cc;

  public C_EQ_S(final F ft, final F fs, final Immediate cc) {
    assert F.INFO.isSupported(ft);
    assert F.INFO.isSupported(fs);
    assert COND_CODE.equals(cc.getType());
    this.ft = ft;
    this.fs = fs;
    this.cc = cc;
  }

  @Override
  public String syntax() {
    return String.format("C_EQ_S %d, %s, %s", cc.access().load().bigIntegerValue(), fs.syntax(), ft.syntax());
  }

  @Override
  public String image() {
    return String.format("01000110000%s%s%s00110010", ft.image(), fs.image(), cc.access().load().toString());
  }

  @Override
  public void action() {
    if (fs.access().load().equals(ft.access().load())) {
      FCCR.access().bitField(cc.access().load(), cc.access().load()).store(Data.valueOf(Type.INT(1), 0x1));
    } else {
      FCCR.access().bitField(cc.access().load(), cc.access().load()).store(Data.valueOf(Type.INT(1), 0x0));
    }
  }
}