/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86;

import ru.ispras.microtesk.model.api.ProcessorModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelPrinter;
import ru.ispras.microtesk.model.api.state.ModelStatePrinter;
import ru.ispras.microtesk.model.api.instruction.AddressingMode;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.x86.metadata.MetaModel;
import ru.ispras.microtesk.model.x86.mode.*;
import ru.ispras.microtesk.model.x86.op.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class Model extends ProcessorModel {
  public static final String NAME = "x86";

  private static final AddressingMode.IInfo[] __MODES = new AddressingMode.IInfo[] {
    GPR16.INFO,
    RSEG16.INFO,
    R8.INFO,
    IMM8.INFO,
    IMM16.INFO,
    DOAM.INFO,
    RIAM_BX.INFO,
    RIAM_SI.INFO,
    RIAM_DI.INFO,
    BIAM_BX_SI.INFO,
    BIAM_BX_DI.INFO,
    BIAM_BP_SI.INFO,
    BIAM_BP_DI.INFO,
    IAM_BX_D8.INFO,
    IAM_BP_D8.INFO,
    IAM_SI_D8.INFO,
    IAM_DI_D8.INFO,
    BIDAM_BX_SI_D8.INFO,
    BIDAM_BX_DI_D8.INFO,
    BIDAM_BP_SI_D8.INFO,
    BIDAM_BP_DI_D8.INFO,
    IAM_BX_D16.INFO,
    IAM_BP_D16.INFO,
    IAM_SI_D16.INFO,
    IAM_DI_D16.INFO,
    BIDAM_BX_SI_D16.INFO,
    BIDAM_BX_DI_D16.INFO,
    BIDAM_BP_SI_D16.INFO,
    BIDAM_BP_DI_D16.INFO
  };

  private static final Operation.IInfo[] __OPS = new Operation.IInfo[] {
    MOV_M8R8.INFO,
    MOV_R8M8.INFO,
    MOV_R8R8.INFO,
    MOV_M16R16.INFO,
    MOV_R16R16.INFO,
    MOV_R16M16.INFO,
    MOV_R16RSEG.INFO,
    MOV_M16RSEG.INFO,
    MOV_RSEGR16.INFO,
    MOV_RSEGM16.INFO,
    MOV_R8IMM8.INFO,
    MOV_R16IMM16.INFO,
    MOV_M8IMM8.INFO,
    MOV_M16IMM16.INFO,
    XCHG_R8R8.INFO,
    XCHG_R8M8.INFO,
    XCHG_R16R16.INFO,
    XCHG_R16M16.INFO,
    PUSH_RSEG.INFO,
    PUSH_R16.INFO,
    PUSH_M16.INFO,
    PUSHA.INFO,
    POP_RSEG.INFO,
    POP_R16.INFO,
    POP_M16.INFO,
    POPA.INFO,
    add_proc_byte.INFO,
    add_proc_word.INFO,
    ADD_M8R8.INFO,
    ADD_M16R16.INFO,
    ADD_R8R8.INFO,
    ADD_R8M8.INFO,
    ADD_R16R16.INFO,
    ADD_R16M16.INFO,
    ADD_R8IMM8.INFO,
    ADD_M8IMM8.INFO,
    ADD_R16IMM16.INFO,
    ADD_M16IMM16.INFO,
    ADC_M8R8.INFO,
    ADC_M16R16.INFO,
    ADC_R8R8.INFO,
    ADC_R8M8.INFO,
    ADC_R16R16.INFO,
    ADC_R16M16.INFO,
    ADC_R8IMM8.INFO,
    ADC_M8IMM8.INFO,
    ADC_R16IMM16.INFO,
    ADC_M16IMM16.INFO,
    sub_proc_byte.INFO,
    sub_proc_word.INFO,
    SUB_M8R8.INFO,
    SUB_M16R16.INFO,
    SUB_R8R8.INFO,
    SUB_R8M8.INFO,
    SUB_R16R16.INFO,
    SUB_R16M16.INFO,
    SUB_R8IMM8.INFO,
    SUB_M8IMM8.INFO,
    SUB_R16IMM16.INFO,
    SUB_M16IMM16.INFO,
    SBB_M8R8.INFO,
    SBB_M16R16.INFO,
    SBB_R8R8.INFO,
    SBB_R8M8.INFO,
    SBB_R16R16.INFO,
    SBB_R16M16.INFO,
    SBB_R8IMM8.INFO,
    SBB_M8IMM8.INFO,
    SBB_R16IMM16.INFO,
    SBB_M16IMM16.INFO,
    inc_proc_byte.INFO,
    inc_proc_word.INFO,
    INC_R8.INFO,
    INC_M8.INFO,
    INC_R16.INFO,
    INC_M16.INFO,
    dec_proc_byte.INFO,
    dec_proc_word.INFO,
    DEC_R8.INFO,
    DEC_M8.INFO,
    DEC_R16.INFO,
    DEC_M16.INFO,
    MUL_R8.INFO,
    MUL_M8.INFO,
    MUL_R16.INFO,
    MUL_M16.INFO,
    IMUL_R8.INFO,
    IMUL_M8.INFO,
    IMUL_R16.INFO,
    IMUL_M16.INFO,
    DIV_R8.INFO,
    DIV_M8.INFO,
    DIV_R16.INFO,
    DIV_M16.INFO,
    IDIV_R8.INFO,
    IDIV_M8.INFO,
    IDIV_R16.INFO,
    IDIV_M16.INFO,
    test_proc_byte.INFO,
    test_proc_word.INFO,
    TEST_R8R8.INFO,
    TEST_M8R8.INFO,
    TEST_R16R16.INFO,
    TEST_M16R16.INFO,
    TEST_R8IMM8.INFO,
    TEST_M8IMM8.INFO,
    TEST_R16IMM16.INFO,
    TEST_M16IMM16.INFO,
    AND_R8R8.INFO,
    AND_M8R8.INFO,
    AND_R8M8.INFO,
    AND_R16R16.INFO,
    AND_M16R16.INFO,
    AND_R16M16.INFO,
    AND_R8IMM8.INFO,
    AND_M8IMM8.INFO,
    AND_R16IMM16.INFO,
    AND_M16IMM16.INFO,
    or_proc_byte.INFO,
    or_proc_word.INFO,
    OR_R8R8.INFO,
    OR_M8R8.INFO,
    OR_R8M8.INFO,
    OR_R16R16.INFO,
    OR_M16R16.INFO,
    OR_R16M16.INFO,
    OR_R8IMM8.INFO,
    OR_M8IMM8.INFO,
    OR_R16IMM16.INFO,
    OR_M16IMM16.INFO,
    xor_proc_byte.INFO,
    xor_proc_word.INFO,
    XOR_R8R8.INFO,
    XOR_M8R8.INFO,
    XOR_R8M8.INFO,
    XOR_R16R16.INFO,
    XOR_M16R16.INFO,
    XOR_R16M16.INFO,
    XOR_R8IMM8.INFO,
    XOR_M8IMM8.INFO,
    XOR_R16IMM16.INFO,
    XOR_M16IMM16.INFO,
    NOT_R8.INFO,
    NOT_M8.INFO,
    NOT_R16.INFO,
    NOT_M16.INFO,
    neg_proc_byte.INFO,
    neg_proc_word.INFO,
    NEG_R8.INFO,
    NEG_M8.INFO,
    NEG_R16.INFO,
    NEG_M16.INFO,
    CMP_M8R8.INFO,
    CMP_M16R16.INFO,
    CMP_R8R8.INFO,
    CMP_R8M8.INFO,
    CMP_R16R16.INFO,
    CMP_R16M16.INFO,
    CMP_R8IMM8.INFO,
    CMP_M8IMM8.INFO,
    CMP_R16IMM16.INFO,
    CMP_M16IMM16.INFO,
    JMP_SHORT.INFO,
    JMP_LONG.INFO,
    JMP_R16.INFO,
    JMP_M16.INFO,
    JO.INFO,
    JNO.INFO,
    JC.INFO,
    JNC.INFO,
    JZ.INFO,
    JNZ.INFO,
    JS.INFO,
    JNS.INFO,
    JP.INFO,
    JPE.INFO,
    JNP.INFO,
    JPO.INFO,
    JA.INFO,
    JAE.INFO,
    JB.INFO,
    JBE.INFO,
    JE.INFO,
    JNE.INFO,
    JNA.INFO,
    JNAE.INFO,
    JNB.INFO,
    JNBE.INFO,
    JG.INFO,
    JGE.INFO,
    JL.INFO,
    JLE.INFO,
    JNG.INFO,
    JNGE.INFO,
    JNL.INFO,
    JNLE.INFO,
    x86.INFO
  };

  public Model() {
    super(
        NAME,
        new MetaModel(),
        __MODES,
        __OPS,
        __REGISTERS,
        __MEMORY,
        __VARIABLES,
        __LABELS
        );
  }

  public static void printInformation() {
    final Model model = new Model();

    final MetaModelPrinter metaModelPrinter = new MetaModelPrinter(model.getMetaData());
    metaModelPrinter.printAll();

    final ModelStatePrinter modelStatePrinter = new ModelStatePrinter(model);
    modelStatePrinter.printRegisters();
  }

  public static void main(String[] args) {
    printInformation();
  }
} 