/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.metadata;

import static ru.ispras.microtesk.model.x86.Shared.*;

import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.metadata.MetaModelBuilder;

/**
 * The {@code MetaModel} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModel extends MetaModelBuilder {
  public MetaModel() {
    addRegister("GPR", WORD, 8);
    addRegister("AX", WORD, 1);
    addRegister("AL", BYTE, 1);
    addRegister("AH", BYTE, 1);
    addRegister("CX", WORD, 1);
    addRegister("CL", BYTE, 1);
    addRegister("CH", BYTE, 1);
    addRegister("DX", WORD, 1);
    addRegister("DL", BYTE, 1);
    addRegister("DH", BYTE, 1);
    addRegister("BX", WORD, 1);
    addRegister("BL", BYTE, 1);
    addRegister("BH", BYTE, 1);
    addRegister("SP", WORD, 1);
    addRegister("BP", WORD, 1);
    addRegister("SI", WORD, 1);
    addRegister("DI", WORD, 1);
    addRegister("RSEG", WORD, 4);
    addRegister("ES", WORD, 1);
    addRegister("CS", WORD, 1);
    addRegister("SS", WORD, 1);
    addRegister("DS", WORD, 1);
    addRegister("IP", WORD, 1);
    addRegister("FLAGS", WORD, 1);

    addMemory("M", BYTE, 0x100000);

    addMode(GPR16.get());
    addMode(RSEG16.get());
    addMode(R8.get());
    addMode(IMM8.get());
    addMode(IMM16.get());
    addMode(DOAM.get());
    addMode(RIAM_BX.get());
    addMode(RIAM_SI.get());
    addMode(RIAM_DI.get());
    addMode(BIAM_BX_SI.get());
    addMode(BIAM_BX_DI.get());
    addMode(BIAM_BP_SI.get());
    addMode(BIAM_BP_DI.get());
    addMode(IAM_BX_D8.get());
    addMode(IAM_BP_D8.get());
    addMode(IAM_SI_D8.get());
    addMode(IAM_DI_D8.get());
    addMode(BIDAM_BX_SI_D8.get());
    addMode(BIDAM_BX_DI_D8.get());
    addMode(BIDAM_BP_SI_D8.get());
    addMode(BIDAM_BP_DI_D8.get());
    addMode(IAM_BX_D16.get());
    addMode(IAM_BP_D16.get());
    addMode(IAM_SI_D16.get());
    addMode(IAM_DI_D16.get());
    addMode(BIDAM_BX_SI_D16.get());
    addMode(BIDAM_BX_DI_D16.get());
    addMode(BIDAM_BP_SI_D16.get());
    addMode(BIDAM_BP_DI_D16.get());
    addMode(MOFFS.get());

    addOperation(MOV_M8R8.get());
    addOperation(MOV_R8M8.get());
    addOperation(MOV_R8R8.get());
    addOperation(MOV_M16R16.get());
    addOperation(MOV_R16R16.get());
    addOperation(MOV_R16M16.get());
    addOperation(MOV_R16RSEG.get());
    addOperation(MOV_M16RSEG.get());
    addOperation(MOV_RSEGR16.get());
    addOperation(MOV_RSEGM16.get());
    addOperation(MOV_R8IMM8.get());
    addOperation(MOV_R16IMM16.get());
    addOperation(MOV_M8IMM8.get());
    addOperation(MOV_M16IMM16.get());
    addOperation(MOV.get());
    addOperation(XCHG_R8R8.get());
    addOperation(XCHG_R8M8.get());
    addOperation(XCHG_R16R16.get());
    addOperation(XCHG_R16M16.get());
    addOperation(XCHG.get());
    addOperation(PUSH_RSEG.get());
    addOperation(PUSH_R16.get());
    addOperation(PUSH_M16.get());
    addOperation(PUSH.get());
    addOperation(PUSHA.get());
    addOperation(POP_RSEG.get());
    addOperation(POP_R16.get());
    addOperation(POP_M16.get());
    addOperation(POP.get());
    addOperation(POPA.get());
    addOperation(add_proc_byte.get());
    addOperation(add_proc_word.get());
    addOperation(ADD_M8R8.get());
    addOperation(ADD_M16R16.get());
    addOperation(ADD_R8R8.get());
    addOperation(ADD_R8M8.get());
    addOperation(ADD_R16R16.get());
    addOperation(ADD_R16M16.get());
    addOperation(ADD_R8IMM8.get());
    addOperation(ADD_M8IMM8.get());
    addOperation(ADD_R16IMM16.get());
    addOperation(ADD_M16IMM16.get());
    addOperation(ADD.get());
    addOperation(ADC_M8R8.get());
    addOperation(ADC_M16R16.get());
    addOperation(ADC_R8R8.get());
    addOperation(ADC_R8M8.get());
    addOperation(ADC_R16R16.get());
    addOperation(ADC_R16M16.get());
    addOperation(ADC_R8IMM8.get());
    addOperation(ADC_M8IMM8.get());
    addOperation(ADC_R16IMM16.get());
    addOperation(ADC_M16IMM16.get());
    addOperation(ADC.get());
    addOperation(sub_proc_byte.get());
    addOperation(sub_proc_word.get());
    addOperation(SUB_M8R8.get());
    addOperation(SUB_M16R16.get());
    addOperation(SUB_R8R8.get());
    addOperation(SUB_R8M8.get());
    addOperation(SUB_R16R16.get());
    addOperation(SUB_R16M16.get());
    addOperation(SUB_R8IMM8.get());
    addOperation(SUB_M8IMM8.get());
    addOperation(SUB_R16IMM16.get());
    addOperation(SUB_M16IMM16.get());
    addOperation(SUB.get());
    addOperation(SBB_M8R8.get());
    addOperation(SBB_M16R16.get());
    addOperation(SBB_R8R8.get());
    addOperation(SBB_R8M8.get());
    addOperation(SBB_R16R16.get());
    addOperation(SBB_R16M16.get());
    addOperation(SBB_R8IMM8.get());
    addOperation(SBB_M8IMM8.get());
    addOperation(SBB_R16IMM16.get());
    addOperation(SBB_M16IMM16.get());
    addOperation(SBB.get());
    addOperation(inc_proc_byte.get());
    addOperation(inc_proc_word.get());
    addOperation(INC_R8.get());
    addOperation(INC_M8.get());
    addOperation(INC_R16.get());
    addOperation(INC_M16.get());
    addOperation(INC.get());
    addOperation(dec_proc_byte.get());
    addOperation(dec_proc_word.get());
    addOperation(DEC_R8.get());
    addOperation(DEC_M8.get());
    addOperation(DEC_R16.get());
    addOperation(DEC_M16.get());
    addOperation(DEC.get());
    addOperation(MUL_R8.get());
    addOperation(MUL_M8.get());
    addOperation(MUL_R16.get());
    addOperation(MUL_M16.get());
    addOperation(MUL.get());
    addOperation(IMUL_R8.get());
    addOperation(IMUL_M8.get());
    addOperation(IMUL_R16.get());
    addOperation(IMUL_M16.get());
    addOperation(IMUL.get());
    addOperation(DIV_R8.get());
    addOperation(DIV_M8.get());
    addOperation(DIV_R16.get());
    addOperation(DIV_M16.get());
    addOperation(DIV.get());
    addOperation(IDIV_R8.get());
    addOperation(IDIV_M8.get());
    addOperation(IDIV_R16.get());
    addOperation(IDIV_M16.get());
    addOperation(IDIV.get());
    addOperation(test_proc_byte.get());
    addOperation(test_proc_word.get());
    addOperation(TEST_R8R8.get());
    addOperation(TEST_M8R8.get());
    addOperation(TEST_R16R16.get());
    addOperation(TEST_M16R16.get());
    addOperation(TEST_R8IMM8.get());
    addOperation(TEST_M8IMM8.get());
    addOperation(TEST_R16IMM16.get());
    addOperation(TEST_M16IMM16.get());
    addOperation(TEST.get());
    addOperation(AND_R8R8.get());
    addOperation(AND_M8R8.get());
    addOperation(AND_R8M8.get());
    addOperation(AND_R16R16.get());
    addOperation(AND_M16R16.get());
    addOperation(AND_R16M16.get());
    addOperation(AND_R8IMM8.get());
    addOperation(AND_M8IMM8.get());
    addOperation(AND_R16IMM16.get());
    addOperation(AND_M16IMM16.get());
    addOperation(AND.get());
    addOperation(or_proc_byte.get());
    addOperation(or_proc_word.get());
    addOperation(OR_R8R8.get());
    addOperation(OR_M8R8.get());
    addOperation(OR_R8M8.get());
    addOperation(OR_R16R16.get());
    addOperation(OR_M16R16.get());
    addOperation(OR_R16M16.get());
    addOperation(OR_R8IMM8.get());
    addOperation(OR_M8IMM8.get());
    addOperation(OR_R16IMM16.get());
    addOperation(OR_M16IMM16.get());
    addOperation(OR.get());
    addOperation(xor_proc_byte.get());
    addOperation(xor_proc_word.get());
    addOperation(XOR_R8R8.get());
    addOperation(XOR_M8R8.get());
    addOperation(XOR_R8M8.get());
    addOperation(XOR_R16R16.get());
    addOperation(XOR_M16R16.get());
    addOperation(XOR_R16M16.get());
    addOperation(XOR_R8IMM8.get());
    addOperation(XOR_M8IMM8.get());
    addOperation(XOR_R16IMM16.get());
    addOperation(XOR_M16IMM16.get());
    addOperation(XOR.get());
    addOperation(NOT_R8.get());
    addOperation(NOT_M8.get());
    addOperation(NOT_R16.get());
    addOperation(NOT_M16.get());
    addOperation(NOT.get());
    addOperation(neg_proc_byte.get());
    addOperation(neg_proc_word.get());
    addOperation(NEG_R8.get());
    addOperation(NEG_M8.get());
    addOperation(NEG_R16.get());
    addOperation(NEG_M16.get());
    addOperation(NEG.get());
    addOperation(CMP_M8R8.get());
    addOperation(CMP_M16R16.get());
    addOperation(CMP_R8R8.get());
    addOperation(CMP_R8M8.get());
    addOperation(CMP_R16R16.get());
    addOperation(CMP_R16M16.get());
    addOperation(CMP_R8IMM8.get());
    addOperation(CMP_M8IMM8.get());
    addOperation(CMP_R16IMM16.get());
    addOperation(CMP_M16IMM16.get());
    addOperation(CMP.get());
    addOperation(JMP_SHORT.get());
    addOperation(JMP_LONG.get());
    addOperation(JMP_R16.get());
    addOperation(JMP_M16.get());
    addOperation(JMP.get());
    addOperation(JO.get());
    addOperation(JNO.get());
    addOperation(JC.get());
    addOperation(JNC.get());
    addOperation(JZ.get());
    addOperation(JNZ.get());
    addOperation(JS.get());
    addOperation(JNS.get());
    addOperation(JP.get());
    addOperation(JPE.get());
    addOperation(JNP.get());
    addOperation(JPO.get());
    addOperation(JA.get());
    addOperation(JAE.get());
    addOperation(JB.get());
    addOperation(JBE.get());
    addOperation(JE.get());
    addOperation(JNE.get());
    addOperation(JNA.get());
    addOperation(JNAE.get());
    addOperation(JNB.get());
    addOperation(JNBE.get());
    addOperation(JG.get());
    addOperation(JGE.get());
    addOperation(JL.get());
    addOperation(JLE.get());
    addOperation(JNG.get());
    addOperation(JNGE.get());
    addOperation(JNL.get());
    addOperation(JNLE.get());
    addOperation(operations.get());
    addOperation(x86.get());
    addOperation(instruction.get());
  }
}
