/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class RSEG16 extends AddressingMode {
  public static final String NAME = "RSEG16";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          RSEG16.class,
          "RSEG16",
          WORD,
          new ArgumentDecls()
              .add("i", INDEX)
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new RSEG16(i);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate i;

  public RSEG16(final Immediate i) {
    this.i = i;
  }

  @Override
  public String syntax() {
    return String.format("%s", i.access().load().equals(Data.valueOf(INDEX, 0x0)) ? "ES" : i.access().load().equals(Data.valueOf(INDEX, 0x1)) ? "CS" : i.access().load().equals(Data.valueOf(INDEX, 0x2)) ? "SS" : i.access().load().equals(Data.valueOf(INDEX, 0x3)) ? "DS" : "ES");
  }

  @Override
  public String image() {
    return String.format("%s", i.access().load().equals(Data.valueOf(INDEX, 0x0)) ? "00" : i.access().load().equals(Data.valueOf(INDEX, 0x1)) ? "01" : i.access().load().equals(Data.valueOf(INDEX, 0x2)) ? "10" : i.access().load().equals(Data.valueOf(INDEX, 0x3)) ? "11" : "000");
  }

  @Override
  public Location access() {
    return RSEG.access(i.access().load()).setName(syntax());
  }
}