/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class CMP_R16R16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         CMP_R16R16.class,
         "CMP_R16R16",
         new ArgumentDecls()
             .add("op1", GPR16.INFO)
             .add("op2", GPR16.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 op1 = (GPR16) getArgument("op1", args);
      final GPR16 op2 = (GPR16) getArgument("op2", args);

      return new CMP_R16R16(op1, op2);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "CMP_R16R16",
          new ArgumentDecls()
              .add("op1", GPR16.INFO)
              .add("op2", GPR16.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final GPR16 op1 = (GPR16) getArgument("op1", args);
      final GPR16 op2 = (GPR16) getArgument("op2", args);

      return new x86(
        new CMP_R16R16(
          op1,
          op2
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final GPR16 op1;
  public final GPR16 op2;

  public CMP_R16R16(final GPR16 op1, final GPR16 op2) {
    assert GPR16.INFO.isSupported(op1);
    assert GPR16.INFO.isSupported(op2);
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public String syntax() {
    return String.format("CMP %s, %s", op1.syntax(), op2.syntax());
  }

  @Override
  public String image() {
    return String.format("0011101111%s%s", op1.image(), op2.image());
  }

  @Override
  public void action() {
    new sub_proc_word(new Immediate(op1.access().load().add(Data.valueOf(WORD, 0x0))), new Immediate(op2.access().load().add(Data.valueOf(WORD, 0x0)))).execute();
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
  }
}