/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class IDIV_R8 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         IDIV_R8.class,
         "IDIV_R8",
         new ArgumentDecls()
             .add("op1", R8.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R8 op1 = (R8) getArgument("op1", args);

      return new IDIV_R8(op1);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "IDIV_R8",
          new ArgumentDecls()
              .add("op1", R8.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R8 op1 = (R8) getArgument("op1", args);

      return new x86(
        new IDIV_R8(
          op1
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R8 op1;

  public IDIV_R8(final R8 op1) {
    assert R8.INFO.isSupported(op1);
    this.op1 = op1;
  }

  @Override
  public String syntax() {
    return String.format("IDIV %s", op1.syntax());
  }

  @Override
  public String image() {
    return String.format("1111011011000%s", op1.image());
  }

  @Override
  public void action() {
    tmpw_op1.access().store(Data.cast(SWORD, AX.access().load()).divide(Data.signExtend(SWORD, Data.cast(SBYTE, op1.access().load()))));
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
    if ((tmpw_op1.access().load().compareTo(Data.valueOf(WORD, 0x7f)) <= 0) && (tmpw_op1.access().load().compareTo(Data.valueOf(WORD, 0x80)) >= 0)) {
      AH.access().store(Data.coerce(BYTE, AX.access().load().mod(Data.signExtend(WORD, Data.cast(SBYTE, op1.access().load())))));
      AL.access().store(Data.coerce(BYTE, tmpw_op1.access().load()));
    }
  }
}