/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class IMUL_R8 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         IMUL_R8.class,
         "IMUL_R8",
         new ArgumentDecls()
             .add("op1", R8.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R8 op1 = (R8) getArgument("op1", args);

      return new IMUL_R8(op1);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "IMUL_R8",
          new ArgumentDecls()
              .add("op1", R8.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R8 op1 = (R8) getArgument("op1", args);

      return new x86(
        new IMUL_R8(
          op1
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final R8 op1;

  public IMUL_R8(final R8 op1) {
    assert R8.INFO.isSupported(op1);
    this.op1 = op1;
  }

  @Override
  public String syntax() {
    return String.format("IMUL %s", op1.syntax());
  }

  @Override
  public String image() {
    return String.format("1111011011000%s", op1.image());
  }

  @Override
  public void action() {
    AX.access().store(Data.signExtend(WORD, Data.cast(SBYTE, AL.access().load())).multiply(Data.signExtend(WORD, Data.cast(SBYTE, op1.access().load()))));
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
    if ((AH.access().load().equals(Data.valueOf(BYTE, 0x0)) || AH.access().load().equals(Data.valueOf(BYTE, 0xff)))) {
      OF.access().store(Data.valueOf(BIT, 0x0));
      CF.access().store(Data.valueOf(BIT, 0x0));
    } else {
      OF.access().store(Data.valueOf(BIT, 0x1));
      CF.access().store(Data.valueOf(BIT, 0x1));
    }
  }
}