/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class JAE extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         JAE.class,
         "JAE",
         new ArgumentDecls()
             .add("rel", SBYTE),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate rel = (Immediate) getArgument("rel", args);

      return new JAE(rel);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "JAE",
          new ArgumentDecls()
              .add("rel", SBYTE)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate rel = (Immediate) getArgument("rel", args);

      return new x86(
        new JAE(
          rel
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate rel;

  public JAE(final Immediate rel) {
    assert SBYTE.equals(rel.getType());
    this.rel = rel;
  }

  @Override
  public String syntax() {
    return String.format("JAE <label>%d", rel.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("01110011%s", rel.access().load().toString());
  }

  @Override
  public void action() {
    if (CF.access().load().equals(Data.valueOf(BIT, 0x0))) {
      IP.access().store(IP.access().load().add(Data.signExtend(WORD, rel.access().load())));
    }
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x2)));
  }
}