/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class JMP_LONG extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         JMP_LONG.class,
         "JMP_LONG",
         new ArgumentDecls()
             .add("rel", SWORD),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate rel = (Immediate) getArgument("rel", args);

      return new JMP_LONG(rel);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "JMP_LONG",
          new ArgumentDecls()
              .add("rel", SWORD)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate rel = (Immediate) getArgument("rel", args);

      return new x86(
        new JMP_LONG(
          rel
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate rel;

  public JMP_LONG(final Immediate rel) {
    assert SWORD.equals(rel.getType());
    this.rel = rel;
  }

  @Override
  public String syntax() {
    return String.format("JMP <label>%d", rel.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("11101001%s", Location.concat(rel.access().bitField(8, 15), rel.access().bitField(0, 7)).load().toString());
  }

  @Override
  public void action() {
    IP.access().store(IP.access().load().add(Data.cast(WORD, rel.access().load())));
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}