/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class MUL_M8 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MUL_M8.class,
         "MUL_M8",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("op1", MOFFS.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);

      return new MUL_M8(seg_ovrd, op1);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "MUL_M8",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("op1", MOFFS.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);

      return new x86(
        new MUL_M8(
          seg_ovrd,
          op1
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final AddressingMode op1;

  public MUL_M8(final RSEG16 seg_ovrd, final AddressingMode op1) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(op1);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
  }

  @Override
  public String syntax() {
    return String.format("MUL %s:%s", seg_ovrd.syntax(), op1.syntax());
  }

  @Override
  public String image() {
    return String.format("001%s11011110110%s000%s%s", seg_ovrd.image(), mod.access().load().toString(), rm.access().load().toString(), op1.image());
  }

  @Override
  public void action() {
    base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    AX.access().store(Data.zeroExtend(WORD, AL.access().load()).multiply(Data.zeroExtend(WORD, M.access(base.access().load().add(op1.access().load())).load())));
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
    op1.execute();
    if (!AH.access().load().equals(Data.valueOf(BYTE, 0x0))) {
      OF.access().store(Data.valueOf(BIT, 0x1));
      CF.access().store(Data.valueOf(BIT, 0x1));
    } else {
      OF.access().store(Data.valueOf(BIT, 0x0));
      CF.access().store(Data.valueOf(BIT, 0x0));
    }
  }
}