/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class POPA extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         POPA.class,
         "POPA",
         new ArgumentDecls(),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new POPA();
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "POPA",
          new ArgumentDecls()
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new x86(
        new POPA()
      );
    }
  }
  public static final IInfo INFO = new Info();

  public POPA() {
  }

  @Override
  public String syntax() {
    return "POPA";
  }

  @Override
  public String image() {
    return "01100001";
  }

  @Override
  public void action() {
    AH.access().store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xf))).load());
    AL.access().store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xe))).load());
    CH.access().store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xd))).load());
    CL.access().store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xc))).load());
    DH.access().store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xb))).load());
    DL.access().store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xa))).load());
    BH.access().store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x9))).load());
    BL.access().store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x8))).load());
    BP.access().bitField(8, 15).store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x5))).load());
    BP.access().bitField(0, 7).store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x4))).load());
    SI.access().bitField(8, 15).store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x3))).load());
    SI.access().bitField(0, 7).store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x2))).load());
    DI.access().bitField(8, 15).store(M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x1))).load());
    DI.access().bitField(0, 7).store(M.access(SS.access().load().add(SP.access().load())).load());
    SP.access().store(SP.access().load().add(Data.valueOf(WORD, 0x10)));
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x1)));
  }
}