/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class XOR_M8R8 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         XOR_M8R8.class,
         "XOR_M8R8",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("op1", MOFFS.INFO)
             .add("op2", R8.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);
      final R8 op2 = (R8) getArgument("op2", args);

      return new XOR_M8R8(seg_ovrd, op1, op2);
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final AddressingMode op1;
  public final R8 op2;

  public XOR_M8R8(final RSEG16 seg_ovrd, final AddressingMode op1, final R8 op2) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(op1);
    assert R8.INFO.isSupported(op2);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public String syntax() {
    return String.format("XOR %s:%s, %s", seg_ovrd.syntax(), op1.syntax(), op2.syntax());
  }

  @Override
  public String image() {
    return String.format("001%s11000110000%s%s%s%s", seg_ovrd.image(), mod.access().load().toString(), op2.image(), rm.access().load().toString(), op1.image());
  }

  @Override
  public void action() {
    base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    new xor_proc_byte(new Immediate(M.access(base.access().load().add(op1.access().load()))), new Immediate(op2.access().load().add(Data.valueOf(Type.CARD(8), 0x0)))).execute();
    M.access(base.access().load().add(op1.access().load())).store(tmpb_res.access().bitField(0, 7).load());
    op1.execute();
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}